#
# GENERATED WITH PDL::PP! Don't modify!
#
package DiaColloDB::PDL::Utils;

our @EXPORT_OK = qw(diacollo_tym_create_ushort diacollo_tym_create_long diacollo_tym_create_indx diacollo_cof_t_ushort diacollo_cof_t_long diacollo_cof_t_indx diacollo_cof_c_ushort diacollo_cof_c_long diacollo_cof_c_indx diacollo_cof_tc_ushort diacollo_cof_tc_long diacollo_cof_tc_indx diacollo_tym_gf_t_ushort diacollo_tym_gf_t_long diacollo_tym_gf_t_indx diacollo_gf_c_ushort diacollo_gf_c_long diacollo_gf_c_indx diacollo_gf_tc_ushort diacollo_gf_tc_long diacollo_gf_tc_indx );
our %EXPORT_TAGS = (Func=>\@EXPORT_OK);

use PDL::Core;
use PDL::Exporter;
use DynaLoader;


   our $VERSION = '0.12.011';
   our @ISA = ( 'PDL::Exporter','DynaLoader' );
   push @PDL::Core::PP, __PACKAGE__;
   bootstrap DiaColloDB::PDL::Utils $VERSION;







#line 33 "pdlutils.pd"

use strict;

=pod

=head1 NAME

DiaColloDB::PDL::Utils - low-level PDL utilities for DiaColloDB

=head1 SYNOPSIS

 use PDL;
 use DiaColloDB::PDL::Utils;

 ##---------------------------------------------------------------------
 ## ... stuff happens

=cut
#line 45 "Utils.pm"

=head1 FUNCTIONS

=cut






=head2 diacollo_tym_create_ushort

=for sig

  Signature: (
    ushort tdmix(Ndims,Nnz);
          tdmnz(Nnz1);
    ushort  d2c(ND);
    ushort c2date(NC);
    ushort [o] nnzOut();
    ; char *ixfile;
    char *nzfile;
    )

Guts for term-year matrix construction from term-document matrix,
used by DiaColloDB::Relation::TDF::create().

=for bad

diacollo_tym_create_ushort does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_tym_create_ushort = \&PDL::diacollo_tym_create_ushort;






=head2 diacollo_tym_create_long

=for sig

  Signature: (
    int tdmix(Ndims,Nnz);
          tdmnz(Nnz1);
    int  d2c(ND);
    ushort c2date(NC);
    int [o] nnzOut();
    ; char *ixfile;
    char *nzfile;
    )

Guts for term-year matrix construction from term-document matrix,
used by DiaColloDB::Relation::TDF::create().

=for bad

diacollo_tym_create_long does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_tym_create_long = \&PDL::diacollo_tym_create_long;






=head2 diacollo_tym_create_indx

=for sig

  Signature: (
    indx tdmix(Ndims,Nnz);
          tdmnz(Nnz1);
    indx  d2c(ND);
    ushort c2date(NC);
    indx [o] nnzOut();
    ; char *ixfile;
    char *nzfile;
    )

Guts for term-year matrix construction from term-document matrix,
used by DiaColloDB::Relation::TDF::create().

=for bad

diacollo_tym_create_indx does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_tym_create_indx = \&PDL::diacollo_tym_create_indx;






=head2 diacollo_cof_t_ushort

=for sig

  Signature: (
    ushort awhich(Ndims,NnzA);
    ushort aptr1(NDplus1);
    ushort apix1(NnzA);
          avals(NnzA1);
    ushort xattrs(NA,NX);
    ushort d2c(ND);
    ushort c2date(NC);
    ushort dateslice();
    ushort mindate();
    ushort maxdate();
    ushort qdocs(NnzQ);
          qvals(NnzQ);
    ushort groupby(NG);
    ushort ghaving(NHaving);
    ; IV f1Hash;
    IV f12Hash;)

Guts for term-document matrix co-frequency acquisition.
Collects co-frequency counts in the HASH-ref $f12Hash and indpendent item1 counts by slice in $f1Hash,
suitable for use with groupby-aggregation over only TERM (cof_t_ITYPE) or CATEGORY (cof_c_ITYPE) attributes.
ITYPE is the index-type used by the underlying tdm model, which see for details.

=for bad

diacollo_cof_t_ushort does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_cof_t_ushort = \&PDL::diacollo_cof_t_ushort;






=head2 diacollo_cof_t_long

=for sig

  Signature: (
    int awhich(Ndims,NnzA);
    int aptr1(NDplus1);
    int apix1(NnzA);
          avals(NnzA1);
    int xattrs(NA,NX);
    int d2c(ND);
    ushort c2date(NC);
    ushort dateslice();
    ushort mindate();
    ushort maxdate();
    int qdocs(NnzQ);
          qvals(NnzQ);
    int groupby(NG);
    int ghaving(NHaving);
    ; IV f1Hash;
    IV f12Hash;)

Guts for term-document matrix co-frequency acquisition.
Collects co-frequency counts in the HASH-ref $f12Hash and indpendent item1 counts by slice in $f1Hash,
suitable for use with groupby-aggregation over only TERM (cof_t_ITYPE) or CATEGORY (cof_c_ITYPE) attributes.
ITYPE is the index-type used by the underlying tdm model, which see for details.

=for bad

diacollo_cof_t_long does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_cof_t_long = \&PDL::diacollo_cof_t_long;






=head2 diacollo_cof_t_indx

=for sig

  Signature: (
    indx awhich(Ndims,NnzA);
    indx aptr1(NDplus1);
    indx apix1(NnzA);
          avals(NnzA1);
    indx xattrs(NA,NX);
    indx d2c(ND);
    ushort c2date(NC);
    ushort dateslice();
    ushort mindate();
    ushort maxdate();
    indx qdocs(NnzQ);
          qvals(NnzQ);
    indx groupby(NG);
    indx ghaving(NHaving);
    ; IV f1Hash;
    IV f12Hash;)

Guts for term-document matrix co-frequency acquisition.
Collects co-frequency counts in the HASH-ref $f12Hash and indpendent item1 counts by slice in $f1Hash,
suitable for use with groupby-aggregation over only TERM (cof_t_ITYPE) or CATEGORY (cof_c_ITYPE) attributes.
ITYPE is the index-type used by the underlying tdm model, which see for details.

=for bad

diacollo_cof_t_indx does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_cof_t_indx = \&PDL::diacollo_cof_t_indx;






=head2 diacollo_cof_c_ushort

=for sig

  Signature: (
    ushort awhich(Ndims,NnzA);
    ushort aptr1(NDplus1);
    ushort apix1(NnzA);
          avals(NnzA1);
    ushort xattrs(NA,NX);
    ushort d2c(ND);
    ushort c2date(NC);
    ushort dateslice();
    ushort mindate();
    ushort maxdate();
    ushort qdocs(NnzQ);
          qvals(NnzQ);
    ushort groupby(NG);
    ushort ghaving(NHaving);
    ; IV f1Hash;
    IV f12Hash;)

Guts for term-document matrix co-frequency acquisition.
Collects co-frequency counts in the HASH-ref $f12Hash and indpendent item1 counts by slice in $f1Hash,
suitable for use with groupby-aggregation over only TERM (cof_t_ITYPE) or CATEGORY (cof_c_ITYPE) attributes.
ITYPE is the index-type used by the underlying tdm model, which see for details.

=for bad

diacollo_cof_c_ushort does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_cof_c_ushort = \&PDL::diacollo_cof_c_ushort;






=head2 diacollo_cof_c_long

=for sig

  Signature: (
    int awhich(Ndims,NnzA);
    int aptr1(NDplus1);
    int apix1(NnzA);
          avals(NnzA1);
    int xattrs(NA,NX);
    int d2c(ND);
    ushort c2date(NC);
    ushort dateslice();
    ushort mindate();
    ushort maxdate();
    int qdocs(NnzQ);
          qvals(NnzQ);
    int groupby(NG);
    int ghaving(NHaving);
    ; IV f1Hash;
    IV f12Hash;)

Guts for term-document matrix co-frequency acquisition.
Collects co-frequency counts in the HASH-ref $f12Hash and indpendent item1 counts by slice in $f1Hash,
suitable for use with groupby-aggregation over only TERM (cof_t_ITYPE) or CATEGORY (cof_c_ITYPE) attributes.
ITYPE is the index-type used by the underlying tdm model, which see for details.

=for bad

diacollo_cof_c_long does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_cof_c_long = \&PDL::diacollo_cof_c_long;






=head2 diacollo_cof_c_indx

=for sig

  Signature: (
    indx awhich(Ndims,NnzA);
    indx aptr1(NDplus1);
    indx apix1(NnzA);
          avals(NnzA1);
    indx xattrs(NA,NX);
    indx d2c(ND);
    ushort c2date(NC);
    ushort dateslice();
    ushort mindate();
    ushort maxdate();
    indx qdocs(NnzQ);
          qvals(NnzQ);
    indx groupby(NG);
    indx ghaving(NHaving);
    ; IV f1Hash;
    IV f12Hash;)

Guts for term-document matrix co-frequency acquisition.
Collects co-frequency counts in the HASH-ref $f12Hash and indpendent item1 counts by slice in $f1Hash,
suitable for use with groupby-aggregation over only TERM (cof_t_ITYPE) or CATEGORY (cof_c_ITYPE) attributes.
ITYPE is the index-type used by the underlying tdm model, which see for details.

=for bad

diacollo_cof_c_indx does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_cof_c_indx = \&PDL::diacollo_cof_c_indx;






=head2 diacollo_cof_tc_ushort

=for sig

  Signature: (
    ushort awhich(Ndims,NnzA);
    ushort aptr1(NDplus1);
    ushort apix1(NnzA);
          avals(NnzA1);
    ushort tattrs(NA,NT);
    ushort mattrs(NM,NC);
    ushort d2c(ND);
    ushort c2date(NC);
    ushort dateslice();
    ushort mindate();
    ushort maxdate();
    ushort qdocs(NnzQ);
          qvals(NnzQ);
    byte  groupas(NG);
    ushort groupby(NG);
    ushort ghavingt(NHavingT);
    ushort ghavingc(NHavingC);
    ; IV f1Hash;
    IV f12Hash;)

Guts for term-document matrix co-frequency acquisition.
Collects co-frequency counts in the HASH-ref $f12Hash and indpendent item1 counts by slice in $f1Hash,
suitable for use with groupby-aggregation over both TERM and CATEGORY attributes.

=for bad

diacollo_cof_tc_ushort does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_cof_tc_ushort = \&PDL::diacollo_cof_tc_ushort;






=head2 diacollo_cof_tc_long

=for sig

  Signature: (
    int awhich(Ndims,NnzA);
    int aptr1(NDplus1);
    int apix1(NnzA);
          avals(NnzA1);
    int tattrs(NA,NT);
    int mattrs(NM,NC);
    int d2c(ND);
    ushort c2date(NC);
    ushort dateslice();
    ushort mindate();
    ushort maxdate();
    int qdocs(NnzQ);
          qvals(NnzQ);
    byte  groupas(NG);
    int groupby(NG);
    int ghavingt(NHavingT);
    int ghavingc(NHavingC);
    ; IV f1Hash;
    IV f12Hash;)

Guts for term-document matrix co-frequency acquisition.
Collects co-frequency counts in the HASH-ref $f12Hash and indpendent item1 counts by slice in $f1Hash,
suitable for use with groupby-aggregation over both TERM and CATEGORY attributes.

=for bad

diacollo_cof_tc_long does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_cof_tc_long = \&PDL::diacollo_cof_tc_long;






=head2 diacollo_cof_tc_indx

=for sig

  Signature: (
    indx awhich(Ndims,NnzA);
    indx aptr1(NDplus1);
    indx apix1(NnzA);
          avals(NnzA1);
    indx tattrs(NA,NT);
    indx mattrs(NM,NC);
    indx d2c(ND);
    ushort c2date(NC);
    ushort dateslice();
    ushort mindate();
    ushort maxdate();
    indx qdocs(NnzQ);
          qvals(NnzQ);
    byte  groupas(NG);
    indx groupby(NG);
    indx ghavingt(NHavingT);
    indx ghavingc(NHavingC);
    ; IV f1Hash;
    IV f12Hash;)

Guts for term-document matrix co-frequency acquisition.
Collects co-frequency counts in the HASH-ref $f12Hash and indpendent item1 counts by slice in $f1Hash,
suitable for use with groupby-aggregation over both TERM and CATEGORY attributes.

=for bad

diacollo_cof_tc_indx does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_cof_tc_indx = \&PDL::diacollo_cof_tc_indx;






=head2 diacollo_tym_gf_t_ushort

=for sig

  Signature: (
    ushort awhich(Ndims,NnzA);
          avals(NnzA1);
    ushort tattrs(NA,NT);
    ushort dateslice();
    ushort mindate();
    ushort maxdate();
    ushort terms2(NT2);
    ushort groupby(NG);
    ; IV f12Hash; IV f2Hash)

Guts for independent group-frequency acquisition from a sparse term-year matrix.
Collects independent group-frequency counts in the HASH-ref f2Hash for any group corresponding to a term-id in $terms2()
whose packed group-key exists in $f12Hash.
Suitable for use with groupby-aggregation over TERM attributes only.

=for bad

diacollo_tym_gf_t_ushort does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_tym_gf_t_ushort = \&PDL::diacollo_tym_gf_t_ushort;






=head2 diacollo_tym_gf_t_long

=for sig

  Signature: (
    int awhich(Ndims,NnzA);
          avals(NnzA1);
    int tattrs(NA,NT);
    ushort dateslice();
    ushort mindate();
    ushort maxdate();
    int terms2(NT2);
    int groupby(NG);
    ; IV f12Hash; IV f2Hash)

Guts for independent group-frequency acquisition from a sparse term-year matrix.
Collects independent group-frequency counts in the HASH-ref f2Hash for any group corresponding to a term-id in $terms2()
whose packed group-key exists in $f12Hash.
Suitable for use with groupby-aggregation over TERM attributes only.

=for bad

diacollo_tym_gf_t_long does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_tym_gf_t_long = \&PDL::diacollo_tym_gf_t_long;






=head2 diacollo_tym_gf_t_indx

=for sig

  Signature: (
    indx awhich(Ndims,NnzA);
          avals(NnzA1);
    indx tattrs(NA,NT);
    ushort dateslice();
    ushort mindate();
    ushort maxdate();
    indx terms2(NT2);
    indx groupby(NG);
    ; IV f12Hash; IV f2Hash)

Guts for independent group-frequency acquisition from a sparse term-year matrix.
Collects independent group-frequency counts in the HASH-ref f2Hash for any group corresponding to a term-id in $terms2()
whose packed group-key exists in $f12Hash.
Suitable for use with groupby-aggregation over TERM attributes only.

=for bad

diacollo_tym_gf_t_indx does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_tym_gf_t_indx = \&PDL::diacollo_tym_gf_t_indx;






=head2 diacollo_gf_c_ushort

=for sig

  Signature: (
    cf(NC);
    ushort cattrs(NA,NC);
    ushort c2date(NC);
    ushort dateslice();
    ushort cats2(NC2);
    ushort groupby(NG);
    ; IV f12Hash; IV f2Hash)

Guts for independent group-frequency acquisition from a dense category-frequency vector $cf().
Collects independent group-frequency counts in the HASH-ref $f2Hash for any group corresponding to a cat-id $cats2()
whose packed group-key exists in $f12Hash.
Suitable for use with groupby-aggregation over CATEGORY attributes only.

=for bad

diacollo_gf_c_ushort does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_gf_c_ushort = \&PDL::diacollo_gf_c_ushort;






=head2 diacollo_gf_c_long

=for sig

  Signature: (
    cf(NC);
    int cattrs(NA,NC);
    ushort c2date(NC);
    ushort dateslice();
    int cats2(NC2);
    int groupby(NG);
    ; IV f12Hash; IV f2Hash)

Guts for independent group-frequency acquisition from a dense category-frequency vector $cf().
Collects independent group-frequency counts in the HASH-ref $f2Hash for any group corresponding to a cat-id $cats2()
whose packed group-key exists in $f12Hash.
Suitable for use with groupby-aggregation over CATEGORY attributes only.

=for bad

diacollo_gf_c_long does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_gf_c_long = \&PDL::diacollo_gf_c_long;






=head2 diacollo_gf_c_indx

=for sig

  Signature: (
    cf(NC);
    indx cattrs(NA,NC);
    ushort c2date(NC);
    ushort dateslice();
    indx cats2(NC2);
    indx groupby(NG);
    ; IV f12Hash; IV f2Hash)

Guts for independent group-frequency acquisition from a dense category-frequency vector $cf().
Collects independent group-frequency counts in the HASH-ref $f2Hash for any group corresponding to a cat-id $cats2()
whose packed group-key exists in $f12Hash.
Suitable for use with groupby-aggregation over CATEGORY attributes only.

=for bad

diacollo_gf_c_indx does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_gf_c_indx = \&PDL::diacollo_gf_c_indx;






=head2 diacollo_gf_tc_ushort

=for sig

  Signature: (
    ushort awhich(Ndims,NnzA);
          avals(NnzA1);
    ushort tattrs(NA,NT);
    ushort mattrs(NM,NC);
    ushort d2c(ND);
    ushort c2date(NC);
    ushort dateslice();
    ushort mindate();
    ushort maxdate();
    byte  groupas(NG);
    ushort groupby(NG);
    ; IV f12Hash; IV f2Hash)

Guts for independent group-frequency acquisition from a sparse term-document matrix.
Collects independent group-frequency counts in the HASH-ref $f2Hash for any group whose packed group-key exists in $f12Hash.
Suitable for use with groupby-aggregation over both TERM and CATEGORY attributes,
but uses a slow linear O(NnzA) scan over the tdm matrix, so avoid it if you can.

=for bad

diacollo_gf_tc_ushort does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_gf_tc_ushort = \&PDL::diacollo_gf_tc_ushort;






=head2 diacollo_gf_tc_long

=for sig

  Signature: (
    int awhich(Ndims,NnzA);
          avals(NnzA1);
    int tattrs(NA,NT);
    int mattrs(NM,NC);
    int d2c(ND);
    ushort c2date(NC);
    ushort dateslice();
    ushort mindate();
    ushort maxdate();
    byte  groupas(NG);
    int groupby(NG);
    ; IV f12Hash; IV f2Hash)

Guts for independent group-frequency acquisition from a sparse term-document matrix.
Collects independent group-frequency counts in the HASH-ref $f2Hash for any group whose packed group-key exists in $f12Hash.
Suitable for use with groupby-aggregation over both TERM and CATEGORY attributes,
but uses a slow linear O(NnzA) scan over the tdm matrix, so avoid it if you can.

=for bad

diacollo_gf_tc_long does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_gf_tc_long = \&PDL::diacollo_gf_tc_long;






=head2 diacollo_gf_tc_indx

=for sig

  Signature: (
    indx awhich(Ndims,NnzA);
          avals(NnzA1);
    indx tattrs(NA,NT);
    indx mattrs(NM,NC);
    indx d2c(ND);
    ushort c2date(NC);
    ushort dateslice();
    ushort mindate();
    ushort maxdate();
    byte  groupas(NG);
    indx groupby(NG);
    ; IV f12Hash; IV f2Hash)

Guts for independent group-frequency acquisition from a sparse term-document matrix.
Collects independent group-frequency counts in the HASH-ref $f2Hash for any group whose packed group-key exists in $f12Hash.
Suitable for use with groupby-aggregation over both TERM and CATEGORY attributes,
but uses a slow linear O(NnzA) scan over the tdm matrix, so avoid it if you can.

=for bad

diacollo_gf_tc_indx does not process bad values.
It will set the bad-value flag of all output ndarrays if the flag is set for any of the input ndarrays.

=cut




*diacollo_gf_tc_indx = \&PDL::diacollo_gf_tc_indx;





#line 993 "pdlutils.pd"

##---------------------------------------------------------------------
=pod

=head1 ACKNOWLEDGEMENTS

Perl by Larry Wall.

PDL by Karl Glazebrook, Tuomas J. Lukka, Christian Soeller, and others.

=cut

##----------------------------------------------------------------------
=pod

=head1 KNOWN BUGS

Probably many.

=cut

##---------------------------------------------------------------------
=pod

=head1 AUTHOR

Bryan Jurish E<lt>moocow@cpan.orgE<gt>

=head2 Copyright Policy

Copyright (C) 2016, Bryan Jurish. All rights reserved.

This package is free software, and entirely without warranty.
You may redistribute it and/or modify it under the same terms
as Perl itself.

=head1 SEE ALSO

perl(1), PDL(3perl)

=cut
#line 937 "Utils.pm"

# Exit with OK status

1;
